Imports System.Runtime.InteropServices
Public Class changeofflinemode
    Private Const INTERNET_OPTION_CONNECTED_STATE As Int32 = 50
    Private Const INTERNET_STATE_CONNECTED As Int32 = 1
    Private Const INTERNET_STATE_DISCONNECTED As Int32 = 2
    Private Const INTERNET_STATE_DISCONNECTED_BY_USER As Int32 = &H10S
    Private Const INTERNET_STATE_IDLE As Int32 = &H100S
    Private Const INTERNET_STATE_BUSY As Int32 = &H200S
    Private Const ISO_FORCE_DISCONNECTED As Int32 = 1

    ''IntPtr hInternet, uint dwOption,ref INTERNET_CONNECTED_INFO lpBuffer, int dwBufferLength);
    'UPGRADE_ISSUE: Declaring a parameter 'As Any' is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1016"'
    <Runtime.InteropServices.DllImport("wininet.dll")> _
Private Shared Function InternetSetOption(ByVal hInternet As IntPtr, _
    ByVal dwOption As Int32, _
    ByRef lpBuffer As INTERNET_CONNECTED_INFO, _
    ByVal dwBufferLength As Int32) As Boolean
    End Function



    Private Structure INTERNET_CONNECTED_INFO
        Dim dwConnectedState As Int32
        Dim dwFlags As Int32
    End Structure
    Public Sub SetOffLineMode(ByVal offLineMode As Boolean)

        Dim ci As INTERNET_CONNECTED_INFO
        Dim retValue As Boolean

        If offLineMode Then
            ci.dwConnectedState = INTERNET_STATE_DISCONNECTED_BY_USER
            ci.dwFlags = ISO_FORCE_DISCONNECTED
        Else
            ci.dwConnectedState = INTERNET_STATE_CONNECTED
        End If

        'UPGRADE_ISSUE: LenB function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        'UPGRADE_WARNING: Couldn't resolve default property of object ci. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1037"'
        retValue = InternetSetOption(IntPtr.Zero, INTERNET_OPTION_CONNECTED_STATE, ci, Marshal.SizeOf(ci))
        If retValue = False Then Err.Raise(vbObjectError + 1000, , "An error occurred calling SetOffLineMode function")
    End Sub
End Class
